#!/usr/bin/perl
#
# $Id: timeout_reset.pl,v 1.2 2004/10/07 14:32:03 martinb1 Exp $
#
###############################################################################
#                                                                             #
# (c)2004, Author: Martin Bachem, Gude Analog- und Digitalsysteme GmbH        #
# 	http://www.gude.info/                                                     #
#                                                                             #
###############################################################################
#
# This perl script supervises a special Host at your network.
# if the host is down, it calls epc_control.pl to switch an EPCnet
# off and on again
#
# please set the following options carefully:

# Host Address wich is to be supervised:
$supervised_host = "192.168.0.10";

# how many seconds needs supervised Host to boot
# !! Attention, must be more than the host needs to reboot if it was down!!
# (be generously here ;)
$supervised_host_boot_time = 180;

# IP Address of EPCnet
$epc_net        = "192.168.0.2";
$epc_switchport = 1;
$epc_password   = "";

# Watch if supervised Host is alive every X seconds
$ping_delay     = 2;

# When supervised Host is down, switch EPCnet off, wait X seconds, then switch on
$switch_delay   = 20;


############################################################################################

eval("use Net::Ping");
if ($@) {
	print "ERROR: Module use Net::Ping not on found this machine\n";
	exit;
}

$bytes = 22;
$timeout = 5;
$pingtype = "icmp";
$ping = Net::Ping->new($pingtype , $timeout , $bytes);


$switch_off = "epc_control.pl --host=$epc_net --password=$epc_password -p=$epc_switchport -off";
$switch_on  = "epc_control.pl --host=$epc_net --password=$epc_password -p=$epc_switchport -on";

print ("Using EPCnet at $epc_net to supervise Host $supervised_host ...\n");

if ($ping->ping($epc_net, 5)) {
	
	while (true) {
		print ("Ping $supervised_host... ");
		$| = 1;
		if ($ping->ping($supervised_host, 5)) {
			print " -> is alive\n"
		} else {
			print " -> is down, switch EPCnet OFF... ";
			$epc_control_result = qx"$switch_off";
			print "done!\n";
			print "waiting $switch_delay seconds... ";
			$| = 1;
			sleep($switch_delay);
			print "done!\n";
			print "switch EPCnet ON... ";
			$| = 1;
			$epc_control_result = qx"$switch_on";
			print "done!\n";
			print "waiting $supervised_host_boot_time seconds to boot $supervised_host... ";
			$| = 1;
			sleep($supervised_host_boot_time);
			print "done!\n\n";
		}
		
		sleep($ping_delay);
	}
} else {
	print ("ERROR: EPCnet seems not to present at $epc_net!\n");
}